--!parent
--!encoding=utf-8

--****************************************************************************
-- @file      LSW CORE LIB: IDLESLEEP
-- @author    Valentin Schmidt
-- @version   0.2
-- @requires  xtra("UIHelper")
-- @desc      Reduces "CPU-Hogging" by letting making projector sleep on idle
--****************************************************************************

----------------------------------------
-- @constructor
----------------------------------------
on new (me)
  $ = me.$
  
  $.loadXtras(me.libdir, ["UIHelper.x32"], ["UIHelper PPC Xtra.xtra"])
  
  -- arbitrary defaults
  $[#SleepTimeForeground] = 25
  $[#SleepTimeBackground] = 50
  $[#SleepTime] = $[#SleepTimeForeground]
  
  me.idleTime(20) -- 50/sec
  
  $.include(me.libdir&"idle.ls")
  
  -- me.ancestor = xtra("UIHelper").new()
  
  return me
end

----------------------------------------
-- 
----------------------------------------
on __destruct (me)
  if member("idle.ls").type=#script then
    member("idle.ls").erase()
  end if
end

----------------------------------------
-- 
----------------------------------------
on setSleepTime (me, foreground, background, now)
  if voidP(now) then now = foreground
  me.$[#SleepTimeForeground] = foreground
  me.$[#SleepTimeBackground] = background
  me.$[#SleepTime] = now
end

----------------------------------------
-- @param {integer} [ms] - in ms, not ticks!
----------------------------------------
on idleTime (me, ms)
  if voidP(ms) then return _movie.idleHandlerPeriod * 1000/60
  else _movie.idleHandlerPeriod = ms * 60 / 1000
end
