--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new ()
on new (me)
  me._class = #Painter
  me.ancestor = $.include($.Qt.libDir&"/classes/iObject.ls").new()
  me._id = $.Qt._qx.newObject(me._class)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"/classes/iObject.ls").new()
	obj._class = #Painter
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- begin (ObjectID) -> bool
on begin (me,p1)
	if ilk(p1)=#instance then p1 = p1._id
  return $.Qt._qx.callObject(me._id,#begin,p1)
end

-- end ()
on end (me)
  $.Qt._qx.callObject(me._id,#end)
end

-- drawArc (int,int,int,int,int,int)
on drawArc (me,p1,p2,p3,p4,p5,p6)
  $.Qt._qx.callObject(me._id,#drawArc,p1,p2,p3,p4,p5,p6)
end

-- drawChord (int,int,int,int,int,int)
on drawChord (me,p1,p2,p3,p4,p5,p6)
  $.Qt._qx.callObject(me._id,#drawChord,p1,p2,p3,p4,p5,p6)
end

-- drawEllipse (int,int,int,int)
on drawEllipse (me,p1,p2,p3,p4)
  $.Qt._qx.callObject(me._id,#drawEllipse,p1,p2,p3,p4)
end

-- drawImage (point|rect,img|string)
on drawImage (me,p1)
  $.Qt._qx.callObject(me._id,#drawImage,p1)
end

-- drawLine (int,int,int,int)
on drawLine (me,p1,p2,p3,p4)
  $.Qt._qx.callObject(me._id,#drawLine,p1,p2,p3,p4)
end

-- drawPath (list)
on drawPath (me,p1)
  $.Qt._qx.callObject(me._id,#drawPath,p1)
end

-- drawPicture (int,int,int)
on drawPicture (me,p1,p2,p3)
  $.Qt._qx.callObject(me._id,#drawPicture,p1,p2,p3)
end

-- drawPie (int,int,int,int,int,int)
on drawPie (me,p1,p2,p3,p4,p5,p6)
  $.Qt._qx.callObject(me._id,#drawPie,p1,p2,p3,p4,p5,p6)
end

-- drawPoint (point)
on drawPoint (me,p1)
  $.Qt._qx.callObject(me._id,#drawPoint,p1)
end

-- drawPoints (list)
on drawPoints (me,p1)
  $.Qt._qx.callObject(me._id,#drawPoints,p1)
end

-- drawPolygon (list)
on drawPolygon (me,p1)
  $.Qt._qx.callObject(me._id,#drawPolygon,p1)
end

-- drawRect (rect)
on drawRect (me,p1)
  $.Qt._qx.callObject(me._id,#drawRect,p1)
end

-- drawRoundedRect (rect,float,float)
on drawRoundedRect (me,p1,p2,p3)
  $.Qt._qx.callObject(me._id,#drawRoundedRect,p1,p2,p3)
end

-- drawText (point|rect,string)
on drawText (me,p1)
  $.Qt._qx.callObject(me._id,#drawText,p1)
end

-- strokePath (pathList)
on strokePath (me,p1)
  $.Qt._qx.callObject(me._id,#strokePath,p1)
end

-- eraseRect (rect)
on eraseRect (me,p1)
  $.Qt._qx.callObject(me._id,#eraseRect,p1)
end

-- fillRect (rect, color)
on fillRect (me,p1,p2)
  $.Qt._qx.callObject(me._id,#fillRect,p1,p2)
end

-- setBackground (color)
on setBackground (me,p1)
  $.Qt._qx.callObject(me._id,#setBackground,p1)
end

-- setBackgroundMode (int)
on setBackgroundMode (me,p1)
  $.Qt._qx.callObject(me._id,#setBackgroundMode,p1)
end

-- setBrush (color,*int)
on setBrush (me,p1,p2)
  $.Qt._qx.callObject(me._id,#setBrush,p1,p2)
end

-- setFont (FontID|string)+(string,int|float,*int,bool)
on setFont (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callObject(me._id,#setFont,p1)
end

-- setLayoutDirection (int)
on setLayoutDirection (me,p1)
  $.Qt._qx.callObject(me._id,#setLayoutDirection,p1)
end

-- setOpacity (float)
on setOpacity (me,p1)
  $.Qt._qx.callObject(me._id,#setOpacity,p1)
end

-- setPen (color,*int,float)
on setPen (me,p1,p2,p3)
  $.Qt._qx.callObject(me._id,#setPen,p1,p2,p3)
end

-- scale (float,float)
on scale (me,p1,p2)
  $.Qt._qx.callObject(me._id,#scale,p1,p2)
end

-- rotate (float)
on rotate (me,p1)
  $.Qt._qx.callObject(me._id,#rotate,p1)
end

-- translate (point)
on translate (me,p1)
  $.Qt._qx.callObject(me._id,#translate,p1)
end

-- save ()
on save (me)
  $.Qt._qx.callObject(me._id,#save)
end

-- restore ()
on restore (me)
  $.Qt._qx.callObject(me._id,#restore)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

