--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new ()
on new (me)
  me._class = #TextCharFormat
  me.ancestor = $.include($.Qt.libDir&"/classes/iObject.ls").new()
  me._id = $.Qt._qx.newObject(me._class)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"/classes/iObject.ls").new()
	obj._class = #TextCharFormat
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- foreground () -> color
on foreground (me)
  return $.Qt._qx.callObject(me._id,#foreground)
end

-- getFont () -> FontID
on getFont (me)
  obj = $.Qt.Font._make($.Qt._qx.callObject(me._id,#getFont))
  me._children.add(obj)
  return obj
end

-- setBackground (color)
on setBackground (me,p1)
  $.Qt._qx.callObject(me._id,#setBackground,p1)
end

-- setFontFamily (string)
on setFontFamily (me,p1)
  $.Qt._qx.callObject(me._id,#setFontFamily,p1)
end

-- setFontItalic (bool)
on setFontItalic (me,p1)
  $.Qt._qx.callObject(me._id,#setFontItalic,p1)
end

-- setFontPointSize (float)
on setFontPointSize (me,p1)
  $.Qt._qx.callObject(me._id,#setFontPointSize,p1)
end

-- setFontUnderline (bool)
on setFontUnderline (me,p1)
  $.Qt._qx.callObject(me._id,#setFontUnderline,p1)
end

-- setFontWeight (int)
on setFontWeight (me,p1)
  $.Qt._qx.callObject(me._id,#setFontWeight,p1)
end

-- setForeground (color)
on setForeground (me,p1)
  $.Qt._qx.callObject(me._id,#setForeground,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

