--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #FontComboBox
  me.ancestor = $.include($.Qt.libDir&"/classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"/classes/iWidget.ls").new()
	obj._class = #FontComboBox
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- count () -> int
on count (me)
  return $.Qt._qx.callWidget(me._id,#count)
end

-- currentIndex () -> int
on currentIndex (me)
  return $.Qt._qx.callWidget(me._id,#currentIndex)
end

-- currentText () -> string
on currentText (me)
  return $.Qt._qx.callWidget(me._id,#currentText)
end

-- findText (string,*int) -> int
on findText (me,p1,p2)
  return $.Qt._qx.callWidget(me._id,#findText,p1,p2)
end

-- getItemText (int) -> string
on getItemText (me,p1)
  return $.Qt._qx.callWidget(me._id,#getItemText,p1)
end

-- setCurrentIndex (int)
on setCurrentIndex (me,p1)
  $.Qt._qx.callWidget(me._id,#setCurrentIndex,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- activated -> string
on activated(me,id,p1)
  me._detach(#activated,id,p1)
end

-- currentIndexChanged -> int
on currentIndexChanged(me,id,p1)
  me._detach(#currentIndexChanged,id,p1)
end

