--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #PushButton
  me.ancestor = $.include($.Qt.libDir&"/classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"/classes/iWidget.ls").new()
	obj._class = #PushButton
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- setChecked (bool)
on setChecked (me,p1)
  $.Qt._qx.callWidget(me._id,#setChecked,p1)
end

-- setDefault (bool)
on setDefault (me,p1)
  $.Qt._qx.callWidget(me._id,#setDefault,p1)
end

-- setFlat (bool)
on setFlat (me,p1)
  $.Qt._qx.callWidget(me._id,#setFlat,p1)
end

-- setIcon (string|image)
on setIcon (me,p1)
  $.Qt._qx.callWidget(me._id,#setIcon,p1)
end

-- setIconSize (int,int)
on setIconSize (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setIconSize,p1,p2)
end

-- setMenu (int)
on setMenu (me,p1)
  $.Qt._qx.callWidget(me._id,#setMenu,p1)
end

-- setText (string)
on setText (me,p1)
  $.Qt._qx.callWidget(me._id,#setText,p1)
end

-- text () -> string
on text (me)
  return $.Qt._qx.callWidget(me._id,#text)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- clicked
on clicked(me,id)
  me._detach(#clicked,id)
end

-- pressed
on pressed(me,id)
  me._detach(#pressed,id)
end

-- released
on released(me,id)
  me._detach(#released,id)
end

