--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #Scintilla
  me.ancestor = $.include($.Qt.libDir&"/classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"/classes/iWidget.ls").new()
	obj._class = #Scintilla
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- clear ()
on clear (me)
  $.Qt._qx.callWidget(me._id,#clear)
end

-- copy ()
on copy (me)
  $.Qt._qx.callWidget(me._id,#copy)
end

-- cut ()
on cut (me)
  $.Qt._qx.callWidget(me._id,#cut)
end

-- isModified () -> bool
on isModified (me)
  return $.Qt._qx.callWidget(me._id,#isModified)
end

-- paste ()
on paste (me)
  $.Qt._qx.callWidget(me._id,#paste)
end

-- print (PrinterID)
on print (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#print,p1)
end

-- redo ()
on redo (me)
  $.Qt._qx.callWidget(me._id,#redo)
end

-- setAutoIndent (bool)
on setAutoIndent (me,p1)
  $.Qt._qx.callWidget(me._id,#setAutoIndent,p1)
end

-- setBraceMatching (int)
on setBraceMatching (me,p1)
  $.Qt._qx.callWidget(me._id,#setBraceMatching,p1)
end

-- setCaretLineBackgroundColor (color)
on setCaretLineBackgroundColor (me,p1)
  $.Qt._qx.callWidget(me._id,#setCaretLineBackgroundColor,p1)
end

-- setCaretLineVisible (bool)
on setCaretLineVisible (me,p1)
  $.Qt._qx.callWidget(me._id,#setCaretLineVisible,p1)
end

-- setFolding (int)
on setFolding (me,p1)
  $.Qt._qx.callWidget(me._id,#setFolding,p1)
end

-- setFont (FontID)
on setFont (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#setFont,p1)
end

-- setLexer (symbol)
on setLexer (me,p1)
  $.Qt._qx.callWidget(me._id,#setLexer,p1)
end

-- setMarginLineNumbers (int,bool)
on setMarginLineNumbers (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setMarginLineNumbers,p1,p2)
end

-- setMarginWidth (int,int|string)
on setMarginWidth (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setMarginWidth,p1,p2)
end

-- setMarginsFont (FontID)
on setMarginsFont (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#setMarginsFont,p1)
end

-- setModified (bool)
on setModified (me,p1)
  $.Qt._qx.callWidget(me._id,#setModified,p1)
end

-- setTabIndents (bool)
on setTabIndents (me,p1)
  $.Qt._qx.callWidget(me._id,#setTabIndents,p1)
end

-- setTabWidth (int)
on setTabWidth (me,p1)
  $.Qt._qx.callWidget(me._id,#setTabWidth,p1)
end

-- setText (string)
on setText (me,p1)
  $.Qt._qx.callWidget(me._id,#setText,p1)
end

-- text () -> string
on text (me)
  return $.Qt._qx.callWidget(me._id,#text)
end

-- undo ()
on undo (me)
  $.Qt._qx.callWidget(me._id,#undo)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- copyAvailable -> bool
on copyAvailable(me,id,p1)
  me._detach(#copyAvailable,id,p1)
end

-- cursorPositionChanged -> int,int
on cursorPositionChanged(me,id,p1,p2)
  me._detach(#cursorPositionChanged,id,p1,p2)
end

-- modificationChanged -> bool
on modificationChanged(me,id,p1)
  me._detach(#modificationChanged,id,p1)
end

-- selectionChanged
on selectionChanged(me,id)
  me._detach(#selectionChanged,id)
end

-- textChanged
on textChanged(me,id)
  me._detach(#textChanged,id)
end

