--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID,int)
on new (me,p1,p2)
  me._class = #Slider
  me.ancestor = $.include($.Qt.libDir&"/classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1,p2)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"/classes/iWidget.ls").new()
	obj._class = #Slider
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- setOrientation (int)
on setOrientation (me,p1)
  $.Qt._qx.callWidget(me._id,#setOrientation,p1)
end

-- setRange (int,int)
on setRange (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setRange,p1,p2)
end

-- setTickInterval (int)
on setTickInterval (me,p1)
  $.Qt._qx.callWidget(me._id,#setTickInterval,p1)
end

-- setTickPosition (int)
on setTickPosition (me,p1)
  $.Qt._qx.callWidget(me._id,#setTickPosition,p1)
end

-- setTracking (bool)
on setTracking (me,p1)
  $.Qt._qx.callWidget(me._id,#setTracking,p1)
end

-- setValue (int)
on setValue (me,p1)
  $.Qt._qx.callWidget(me._id,#setValue,p1)
end

-- value () -> int
on value (me)
  return $.Qt._qx.callWidget(me._id,#value)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- sliderMoved -> int
on sliderMoved(me,id,p1)
  me._detach(#sliderMoved,id,p1)
end

-- valueChanged -> int
on valueChanged(me,id,p1)
  me._detach(#valueChanged,id,p1)
end

