--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #TextEdit
  me.ancestor = $.include($.Qt.libDir&"/classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"/classes/iWidget.ls").new()
	obj._class = #TextEdit
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- alignment () -> int
on alignment (me)
  return $.Qt._qx.callWidget(me._id,#alignment)
end

-- clear ()
on clear (me)
  $.Qt._qx.callWidget(me._id,#clear)
end

-- copy ()
on copy (me)
  $.Qt._qx.callWidget(me._id,#copy)
end

-- createStandardContextMenu () -> MenuID
on createStandardContextMenu (me)
  obj = $.Qt.Menu._make($.Qt._qx.callWidget(me._id,#createStandardContextMenu))
  me._children.add(obj)
  return obj
end

-- currentCharFormat () -> TextCharFormatID
on currentCharFormat (me)
  obj = $.Qt.TextCharFormat._make($.Qt._qx.callWidget(me._id,#currentCharFormat))
  me._children.add(obj)
  return obj
end

-- cut ()
on cut (me)
  $.Qt._qx.callWidget(me._id,#cut)
end

-- ensureCursorVisible ()
on ensureCursorVisible (me)
  $.Qt._qx.callWidget(me._id,#ensureCursorVisible)
end

-- findText (string,*int) -> bool
on findText (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#findText,p1,p2)
end

-- isModified () -> bool
on isModified (me)
  return $.Qt._qx.callWidget(me._id,#isModified)
end

-- mergeCurrentCharFormat (TextCharFormatID)
on mergeCurrentCharFormat (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#mergeCurrentCharFormat,p1)
end

-- paste ()
on paste (me)
  $.Qt._qx.callWidget(me._id,#paste)
end

-- print (PrinterID)
on print (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#print,p1)
end

-- redo ()
on redo (me)
  $.Qt._qx.callWidget(me._id,#redo)
end

-- selectAll ()
on selectAll (me)
  $.Qt._qx.callWidget(me._id,#selectAll)
end

-- setAcceptRichText (bool)
on setAcceptRichText (me,p1)
  $.Qt._qx.callWidget(me._id,#setAcceptRichText,p1)
end

-- setAlignment (int)
on setAlignment (me,p1)
  $.Qt._qx.callWidget(me._id,#setAlignment,p1)
end

-- setAutoFormatting (int)
on setAutoFormatting (me,p1)
  $.Qt._qx.callWidget(me._id,#setAutoFormatting,p1)
end

-- setCurrentFont (FontID)
on setCurrentFont (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#setCurrentFont,p1)
end

-- setFontFamily (string)
on setFontFamily (me,p1)
  $.Qt._qx.callWidget(me._id,#setFontFamily,p1)
end

-- setFontItalic (bool)
on setFontItalic (me,p1)
  $.Qt._qx.callWidget(me._id,#setFontItalic,p1)
end

-- setFontPointSize (float)
on setFontPointSize (me,p1)
  $.Qt._qx.callWidget(me._id,#setFontPointSize,p1)
end

-- setFontUnderline (bool)
on setFontUnderline (me,p1)
  $.Qt._qx.callWidget(me._id,#setFontUnderline,p1)
end

-- setFontWeight (int)
on setFontWeight (me,p1)
  $.Qt._qx.callWidget(me._id,#setFontWeight,p1)
end

-- setHtml (string)
on setHtml (me,p1)
  $.Qt._qx.callWidget(me._id,#setHtml,p1)
end

-- setLineWrapMode (int)
on setLineWrapMode (me,p1)
  $.Qt._qx.callWidget(me._id,#setLineWrapMode,p1)
end

-- setModified (bool)
on setModified (me,p1)
  $.Qt._qx.callWidget(me._id,#setModified,p1)
end

-- setOverwriteMode (bool)
on setOverwriteMode (me,p1)
  $.Qt._qx.callWidget(me._id,#setOverwriteMode,p1)
end

-- setReadOnly (bool)
on setReadOnly (me,p1)
  $.Qt._qx.callWidget(me._id,#setReadOnly,p1)
end

-- setTabChangesFocus (bool)
on setTabChangesFocus (me,p1)
  $.Qt._qx.callWidget(me._id,#setTabChangesFocus,p1)
end

-- setTabStopWidth (int)
on setTabStopWidth (me,p1)
  $.Qt._qx.callWidget(me._id,#setTabStopWidth,p1)
end

-- setText (string)
on setText (me,p1)
  $.Qt._qx.callWidget(me._id,#setText,p1)
end

-- setTextBackgroundColor (color)
on setTextBackgroundColor (me,p1)
  $.Qt._qx.callWidget(me._id,#setTextBackgroundColor,p1)
end

-- setTextColor (color)
on setTextColor (me,p1)
  $.Qt._qx.callWidget(me._id,#setTextColor,p1)
end

-- setWordWrapMode (int)
on setWordWrapMode (me,p1)
  $.Qt._qx.callWidget(me._id,#setWordWrapMode,p1)
end

-- text () -> string
on text (me)
  return $.Qt._qx.callWidget(me._id,#text)
end

-- toHtml () -> string
on toHtml (me)
  return $.Qt._qx.callWidget(me._id,#toHtml)
end

-- toPlainText () -> string
on toPlainText (me)
  return $.Qt._qx.callWidget(me._id,#toPlainText)
end

-- undo ()
on undo (me)
  $.Qt._qx.callWidget(me._id,#undo)
end

-- write (string,*string) -> bool
on write (me,p1,p2)
  return $.Qt._qx.callWidget(me._id,#write,p1,p2)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- copyAvailable -> bool
on copyAvailable(me,id,p1)
  me._detach(#copyAvailable,id,p1)
end

-- currentCharFormatChanged
on currentCharFormatChanged(me,id)
  me._detach(#currentCharFormatChanged,id)
end

-- cursorPositionChanged
on cursorPositionChanged(me,id)
  me._detach(#cursorPositionChanged,id)
end

-- modificationChanged -> bool
on modificationChanged(me,id,p1)
  me._detach(#modificationChanged,id,p1)
end

-- redoAvailable -> bool
on redoAvailable(me,id,p1)
  me._detach(#redoAvailable,id,p1)
end

-- selectionChanged
on selectionChanged(me,id)
  me._detach(#selectionChanged,id)
end

-- textChanged
on textChanged(me,id)
  me._detach(#textChanged,id)
end

-- undoAvailable -> bool
on undoAvailable(me,id,p1)
  me._detach(#undoAvailable,id,p1)
end

